
;GLOBALS-------------------------------------------------------------------------------------------

Global windowfont%
Global buttonfont%
Global itemfont%
Global sliderfont%
Global switchfont%
Global labelfont%
Global intakefont%
Global status1$
Global status2$
Global status3$
Global status4$
Global status5$
Global sjintakestring$
Global sjcursorblink%
Global sjcursorblinkrate=30
Global statustime%=MilliSecs()
Global tooltiptime%=MilliSecs()
Global menuactive%
Global lastelement%
Global frameheight%
Global collider%=CreateImage(1,1)

Type element
	Field ex%;element position x
	Field ey%;element position y
	Field ew%;element width
	Field eh%;element height
	Field en$;element text
	Field etl%;element text location
	Field ec%;element text center
	Field eo%;element over gfx
	Field ed%;element down gfx
	Field er%;element release gfx
	Field ei%;element index
	Field ea%;element active
	Field el%;element leave
	Field et$;element type
	Field ef%;element font
	Field ep%;element parent ID
	Field ev%;element visible
	Field es%;element selectable
	Field ett$;element tooltip
	Field esw%;element switch status
	
	Field sa%;slider active
	Field sr%;slider range
	Field sb%;slider bar
	Field sbx%;slider bar position x
	Field sby%;slider bar position y
	Field sv#;slider value
	Field sd#;slider displayed value
	Field sm#;slider value modifier
	Field so%;slider orientation
	
	Field ia%;item active
	Field ic$;item content
	
	Field mg%;menu gfx
	
	Field ta%;intake active
End Type

;FUNCTIONS-----------------------------------------------------------------------------------------

Function GuiAction(id%,value#,content$)
	If menuactive%=0 Then
		Select id%
			Case 1040
				End
				
			Case 500
				For gui.element=Each element
					If gui\ei%=id% Then
						If gui\esw%=1 Then HideEntity cube% Else ShowEntity cube%
					End If
				Next
				
			Case 510
				For gui.element=Each element
					If gui\ei%=id% Then
						If gui\esw%=1 Then rotdir#=-1 Else rotdir#=1
					End If
				Next
				
		End Select
	End If
	statustime%=MilliSecs()
End Function

Function SetGUIFont(fontname$)
	windowfont%=LoadFont(fontname$,14)
	buttonfont%=LoadFont(fontname$,18)
	itemfont%=LoadFont(fontname$,16)
	sliderfont%=LoadFont(fontname$,16)
	switchfont%=LoadFont(fontname$,16)
	labelfont%=LoadFont(fontname$,16,1)
	intakefont%=LoadFont(fontname$,14)
End Function	
	
Function InitSJGUIWindow(iconpath$,maximized%)
	Local hwnd = SystemProperty( "AppHWND" )
	Local icon=api_ExtractIcon(hwnd,iconpath$,0)
	api_SendMessage(hwnd, $80 , 0, icon)
	api_SendMessage(hwnd, $80 , 1, icon)
	
	If maximized%=True Then
		Local GWL_STYLE%
		hwnd%=api_GetActiveWindow()
		Local iStyle%=api_GetWindowLong(hwnd%,GWL_STYLE)
		api_SetWindowLong(hwnd%,GWL_STYLE%,iStyle% Or $10000)
		api_ShowWindow(hwnd%,3)
	End If
	
	MV_Start(hwnd%)
End Function

Function SetBarHeight(height%)
	frameheight%=height%
End Function

Function UpdateWindowFrame()
	SetFont windowfont%
	Color 60,60,60
	Rect 0,0,winwidth%,frameheight%+1,1
	Rect 0,winheight%-(frameheight%+1),winwidth%,(frameheight%+1),1
	Color 230,230,230
	Rect 0,0,winwidth%,frameheight%,1
	Rect 0,winheight%-frameheight%,winwidth%,frameheight%,1
	Color 60,60,60
	Text 2,winheight%-(frameheight%*0.5),status1$,0,1
	Text winwidth%*0.25,winheight%-(frameheight%*0.5),status2$,1,1
	Text winwidth%*0.5,winheight%-(frameheight%*0.5),status3$,1,1
	Text winwidth%*0.75,winheight%-(frameheight%*0.5),status4$,1,1
	Text winwidth%-StringWidth(status5$)-2,winheight%-(frameheight%*0.5),status5$,0,1
End Function

Function ResetStatus()
	If MilliSecs()>statustime%+2000 Then
		status1$=""
		status2$=""
		status3$=""
		status4$=""
		status5$=""
		statustime%=MilliSecs()
	End If
End Function	

Function GuiStyle(imageover%,imagedown%,imagerelease%,width%,height%,path$,menugfx%,style$);(Standard|Offset|RoundMood|SquareGliss|RoundBald|Groove|CylindricH|CylindricV|Classic|SquareGloss|Plane)
	Local frame%=2,i%,img%,diam%
	Select style$
		Case "Standard"	
			SetBuffer ImageBuffer(imageover%)
			ClsColor 105,105,105:Cls
			Color 255,255,255
			Rect 0,0,width%-1,height%-1,1
			Color 160,160,160
			Rect 1,1,width%-2,height%-2,1
			Color 227,227,227
			Rect 1,1,width%-3,height%-3,1
			Color 240,240,240
			Rect 2,2,width%-5,height%-5,1
			
			SetBuffer ImageBuffer(imagedown%)
			ClsColor 100,100,100:Cls
			Color 160,160,160
			Rect 2,2,width%-4,height%-4,1
			Color 240,240,240
			Rect 3,3,width%-6,height%-6,1
			Color 60,60,60
			For i%=6 To width%-6 Step 2
				Rect i%,6,1,1,1
				Rect i%,height%-6,1,1,1
			Next
			For i%=6 To height%-6 Step 2
				Rect 6,i%,1,1,1
				Rect width%-6,i%,1,1,1
			Next	
			
			SetBuffer ImageBuffer(imagerelease%)
			ClsColor 105,105,105:Cls
			Color 255,255,255
			Rect 0,0,width%-1,height%-1,1
			Color 160,160,160
			Rect 1,1,width%-2,height%-2,1
			Color 227,227,227
			Rect 1,1,width%-3,height%-3,1
			Color 240,240,240
			Rect 2,2,width%-5,height%-5,1
			
			
		Case "Offset"	
			SetBuffer ImageBuffer(imageover%)
			ClsColor 255,0,255:Cls
			Color 80,80,80
			Rect 4,4,width%-4,height%-4,1
			Color 240,240,240
			Rect 2,2,width%-4,height%-4,1
			Color 60,60,60
			Rect 2,2,width%-4,height%-4,0
			MaskImage imageover%,255,0,255
			
			SetBuffer ImageBuffer(imagedown%)
			ClsColor 255,0,255:Cls
			Color 80,80,80
			Rect 4,4,width%-4,height%-4,1
			Color 240,240,240
			Rect 2,2,width%-4,height%-4,1
			Color 60,60,60
			Rect 2,2,width%-4,height%-4,0
			MaskImage imagedown%,255,0,255
			
			SetBuffer ImageBuffer(imagerelease%)
			ClsColor 255,0,255:Cls
			Color 80,80,80
			Rect 4,4,width%-4,height%-4,1
			Color 240,240,240
			Rect 2,2,width%-4,height%-4,1
			Color 60,60,60
			Rect 2,2,width%-4,height%-4,0
			MaskImage imagerelease%,255,0,255
			
		Case "RoundMood"	
			SetBuffer ImageBuffer(imageover%)
			ClsColor 255,0,255:Cls
			Color 250,210,110
			Oval 0,0,width%,height%,1
			Color 60,60,60
			Oval 0,0,width%,height%,0
			MaskImage imageover%,255,0,255
			
			SetBuffer ImageBuffer(imagedown%)
			ClsColor 255,0,255:Cls
			Color 250,210,110
			Oval 2,2,width%-4,height%-4,1
			Color 60,60,60
			Oval 2,2,width%-4,height%-4,0
			MaskImage imagedown%,255,0,255
			
			SetBuffer ImageBuffer(imagerelease%)
			ClsColor 255,0,255:Cls
			Color 240,200,100
			Oval 0,0,width%,height%,1
			Color 60,60,60
			Oval 0,0,width%,height%,0
			MaskImage imagerelease%,255,0,255
			
		Case "SquareGliss"
			SetBuffer ImageBuffer(imageover%)
			Color 60,60,60
			Rect 0,0,width%,height%,1
			For i%=frame% To height%-(frame%*2)
				Color 190-i%,230-i%,230-i%
				Rect frame%,i%,width%-(frame%*2),frame%,1
			Next
			Color 190,230,230
			Oval frame%,-height%*0.5,width%-(frame%*2),height%,1
			Color 60,60,60
			Rect 0,0,width%,frame%,1
			
			SetBuffer ImageBuffer(imagedown%)
			ClsColor 0,0,0:Cls
			Color 60,60,60
			Rect 0,0,width%,height%,1
			Color 185,225,225
			Rect frame%,frame%,width%-(frame%*2),height%-(frame%*2),1
			
			frame%=1
			SetBuffer ImageBuffer(imagerelease%)
			Color 60,60,60
			Rect 0,0,width%,height%,1
			For i%=frame% To height%-(frame%*2)
				Color 180-i%,220-i%,220-i%
				Rect frame%,i%,width%-(frame%*2),frame%,1
			Next
			Color 180,220,220
			Oval frame%,-height%*0.5,width%-(frame%*2),height%,1
			Color 60,60,60
			Rect 0,0,width%,frame%,1
			
		Case "RoundBald"
			diam%=18
			frame%=10
			SetBuffer ImageBuffer(imageover%)
			ClsColor 255,0,255:Cls
			Color 234,211,123
			Oval 0,0,diam%,diam%,1
			Oval width%-diam%,0,diam%,diam%,1
			Oval 0,height%-diam%,diam%,diam%,1
			Oval width%-diam%,height%-diam%,diam%,diam%,1
			Color 60,60,60
			Oval 0,0,diam%,diam%,0
			Oval width%-diam%,0,diam%,diam%,0
			Oval 0,height%-diam%,diam%,diam%,0
			Oval width%-diam%,height%-diam%,diam%,diam%,0
			Color 234,211,123
			Rect 0,diam%*0.5,width%,height%-diam%,1
			Rect diam%*0.5,0,width%-diam%,height%,1
			Color 60,60,60
			Rect 0,diam%*0.5,1,height%-diam%,1
			Rect width%-1,diam%*0.5,1,height%-diam%,1
			Rect diam%*0.5,0,width%-diam%,1,1
			Rect diam%*0.5,height%-1,width%-diam%,1,1
			Color 230,230,220
			Oval (frame%*0.5),(frame%*0.5),frame%,frame%,1
			Oval width%-(frame%*1.5),(frame%*0.5),frame%,frame%,1
			Oval (frame%*0.5),height%-(frame%*1.5),frame%,frame%,1
			Oval width%-(frame%*1.5),height%-(frame%*1.5),frame%,frame%,1
			Rect (frame%),(frame%)*0.5,width%-frame%*2,height%-frame%,1
			Rect (frame%)*0.5,(frame%),width%-frame%,height%-frame%*2,1
			MaskImage imageover%,255,0,255
			
			SetBuffer ImageBuffer(imagedown%)
			ClsColor 255,0,255:Cls
			Color 234,170,123
			Oval 0,0,diam%,diam%,1
			Oval width%-diam%,0,diam%,diam%,1
			Oval 0,height%-diam%,diam%,diam%,1
			Oval width%-diam%,height%-diam%,diam%,diam%,1
			Color 60,60,60
			Oval 0,0,diam%,diam%,0
			Oval width%-diam%,0,diam%,diam%,0
			Oval 0,height%-diam%,diam%,diam%,0
			Oval width%-diam%,height%-diam%,diam%,diam%,0
			Color 234,170,123
			Rect 0,diam%*0.5,width%,height%-diam%,1
			Rect diam%*0.5,0,width%-diam%,height%,1
			Color 60,60,60
			Rect 0,diam%*0.5,1,height%-diam%,1
			Rect width%-1,diam%*0.5,1,height%-diam%,1
			Rect diam%*0.5,0,width%-diam%,1,1
			Rect diam%*0.5,height%-1,width%-diam%,1,1
			Color 230,230,220
			Oval (frame%*0.5),(frame%*0.5),frame%,frame%,1
			Oval width%-(frame%*1.5),(frame%*0.5),frame%,frame%,1
			Oval (frame%*0.5),height%-(frame%*1.5),frame%,frame%,1
			Oval width%-(frame%*1.5),height%-(frame%*1.5),frame%,frame%,1
			Rect (frame%),(frame%)*0.5,width%-frame%*2,height%-frame%,1
			Rect (frame%)*0.5,(frame%),width%-frame%,height%-frame%*2,1
			MaskImage imagedown%,255,0,255
			
			SetBuffer ImageBuffer(imagerelease%)
			ClsColor 255,0,255:Cls
			Color 234,211,123
			Oval 0,0,diam%,diam%,1
			Oval width%-diam%,0,diam%,diam%,1
			Oval 0,height%-diam%,diam%,diam%,1
			Oval width%-diam%,height%-diam%,diam%,diam%,1
			Color 60,60,60
			Oval 0,0,diam%,diam%,0
			Oval width%-diam%,0,diam%,diam%,0
			Oval 0,height%-diam%,diam%,diam%,0
			Oval width%-diam%,height%-diam%,diam%,diam%,0
			Color 234,211,123
			Rect 0,diam%*0.5,width%,height%-diam%,1
			Rect diam%*0.5,0,width%-diam%,height%,1
			Color 60,60,60
			Rect 0,diam%*0.5,1,height%-diam%,1
			Rect width%-1,diam%*0.5,1,height%-diam%,1
			Rect diam%*0.5,0,width%-diam%,1,1
			Rect diam%*0.5,height%-1,width%-diam%,1,1
			Color 250,250,240
			Oval (frame%*0.5),(frame%*0.5),frame%,frame%,1
			Oval width%-(frame%*1.5),(frame%*0.5),frame%,frame%,1
			Oval (frame%*0.5),height%-(frame%*1.5),frame%,frame%,1
			Oval width%-(frame%*1.5),height%-(frame%*1.5),frame%,frame%,1
			Rect (frame%),(frame%)*0.5,width%-frame%*2,height%-frame%,1
			Rect (frame%)*0.5,(frame%),width%-frame%,height%-frame%*2,1
			MaskImage imagerelease%,255,0,255
			
		Case "Groove"
			SetBuffer ImageBuffer(imageover%)
			ClsColor 255,0,255:Cls
			For i%=0 To width%*0.5
				Color 150+i%*4,150+i%*4,150+i%*4
				Rect i%,0,1,height%,1
				Rect width%-i%,0,1,height%,1
			Next
			Color 220,220,220
			Oval frame%,-height%*0.5,width%-(frame%*2),height%,1
			Color 180,180,180
			Oval frame%,height%-height%*0.5,width%-(frame%*2),height%,1
			Color 60,60,60
			Rect 0,0,width%,height%,0
			Rect 1,1,width%-2,height%-2,0
			MaskImage imageover%,255,0,255
			
			SetBuffer ImageBuffer(imagedown%)
			ClsColor 255,0,255:Cls
			For i%=0 To width%*0.5
				Color 150+i%*4,150+i%*4,150+i%*4
				Rect i%,0,1,height%,1
				Rect width%-i%,0,1,height%,1
			Next
			Color 220,220,220
			Oval frame%,-height%*0.5,width%-(frame%*2),height%,1
			Color 180,180,180
			Oval frame%,height%-height%*0.5,width%-(frame%*2),height%,1
			Color 60,60,60
			Rect 0,0,width%,height%,0
			Rect 1,1,width%-2,height%-2,0
			MaskImage imagedown%,255,0,255
			
			SetBuffer ImageBuffer(imagerelease%)
			ClsColor 255,0,255:Cls
			For i%=0 To width%*0.5
				Color 150+i%*4,150+i%*4,150+i%*4
				Rect i%,0,1,height%,1
				Rect width%-i%,0,1,height%,1
			Next
			Color 220,220,220
			Oval frame%,-height%*0.5,width%-(frame%*2),height%,1
			Color 180,180,180
			Oval frame%,height%-height%*0.5,width%-(frame%*2),height%,1
			Color 60,60,60
			Rect 0,0,width%,height%,0
			MaskImage imagerelease%,255,0,255
			
		Case "CylindricH"
			SetBuffer ImageBuffer(imageover%)
			ClsColor 255,0,255:Cls
			For i%=0 To width%*0.5
				Color 160+i%*3,160+i%*3,160+i%*3
				Rect i%,0,1,height%,1
				Rect width%-i%,0,1,width%,1
			Next
			Color 80,80,80
			Rect width%-2,0,2,height%,1
			Color 200,200,200
			Rect 0,0,3,height%,1
			Color 60,60,60
			Rect 0,0,width%,height%,0
			MaskImage imageover%,255,0,255
			
			SetBuffer ImageBuffer(imagedown%)
			ClsColor 255,0,255:Cls
			For i%=0 To width%*0.5
				Color 160+i%*3,160+i%*3,160+i%*3
				Rect i%,0,1,height%,1
				Rect width%-i%,0,1,width%,1
			Next
			Color 80,80,80
			Rect width%-2,0,2,height%,1
			Color 200,200,200
			Rect 0,0,3,height%,1
			Color 60,60,60
			Rect 0,0,width%,height%,0
			Rect 1,1,width%-2,height%-2,0
			MaskImage imagedown%,255,0,255
			
			SetBuffer ImageBuffer(imagerelease%)
			ClsColor 255,0,255:Cls
			For i%=0 To width%*0.5
				Color 160+i%*3,160+i%*3,160+i%*3
				Rect i%,0,1,height%,1
				Rect width%-i%,0,1,width%,1
			Next
			Color 80,80,80
			Rect width%-2,0,2,height%,1
			Color 200,200,200
			Rect 0,0,3,height%,1
			Color 60,60,60
			Rect 0,0,width%,height%,0
			
		Case "CylindricV"
			SetBuffer ImageBuffer(imageover%)
			ClsColor 255,0,255:Cls
			For i%=0 To height%*0.5
				Color 160+i%*3,160+i%*3,160+i%*3
				Rect 0,i%,width%,1,1
				Rect 0,height%-i%,width%,1,1
			Next
			Color 80,80,80
			Rect 0,height%-2,width%,2,1
			Color 200,200,200
			Rect 0,0,width%,3,1
			Color 80,80,80
			Rect 0,0,width%,height%,0
			MaskImage imageover%,255,0,255
			
			SetBuffer ImageBuffer(imagedown%)
			ClsColor 255,0,255:Cls
			For i%=0 To height%*0.5
				Color 160+i%*3,160+i%*3,160+i%*3
				Rect 0,i%,width%,1,1
				Rect 0,height%-i%,width%,1,1
			Next
			Color 80,80,80
			Rect 0,height%-2,width%,2,1
			Color 200,200,200
			Rect 0,0,width%,2,1
			Color 80,80,80
			Rect 0,0,width%,height%,0
			Rect 1,1,width%-2,height%-2,0
			MaskImage imagedown%,255,0,255
			
			SetBuffer ImageBuffer(imagerelease%)
			ClsColor 255,0,255:Cls
			For i%=0 To height%*0.5
				Color 150+i%*3,150+i%*3,150+i%*3
				Rect 0,i%,width%,1,1
				Rect 0,height%-i%,width%,1,1
			Next
			Color 80,80,80
			Rect 0,height%-2,width%,2,1
			Color 200,200,200
			Rect 0,0,width%,3,1
			Color 80,80,80
			Rect 0,0,width%,height%,0
			
		Case "Classic"
			SetBuffer ImageBuffer(imageover%)
			For i%=0 To height%
				Color 230-i%*3,230-i%*3,230-i%*3
				Rect 0,i%,width%,1,1
			Next
			Color 255,255,235
			Rect 4,4,width%-8,height%-8,1
			Color 80,80,80
			Rect 4,4,width%-8,1,1
			Rect width%-4,4,1,height%-8,1
			Color 60,60,60
			Rect 0,0,width%,height%,0
			
			SetBuffer ImageBuffer(imagedown%)
			For i%=0 To height%
				Color 230-i%*3,230-i%*3,230-i%*3
				Rect 0,i%,width%,1,1
			Next
			Color 255,255,235
			Rect 4,4,width%-8,height%-8,1
			Color 80,80,80
			Rect 4,4,width%-8,1,1
			Rect width%-4,4,1,height%-8,1
			Color 60,60,60
			Rect 0,0,width%,height%,0
			
			SetBuffer ImageBuffer(imagerelease%)
			For i%=0 To height%
				Color 230-i%*3,230-i%*3,230-i%*3
				Rect 0,i%,width%,1,1
			Next
			Color 255,255,255
			Rect 4,4,width%-8,height%-8,1
			Color 80,80,80
			Rect 4,4,width%-8,1,1
			Rect width%-4,4,1,height%-8,1
			Color 60,60,60
			Rect 0,0,width%,height%,0
			
		Case "SquareGloss"
			If path$<>"" Then img%=LoadImage(path$)
			If path$<>"" Then 
				ResizeImage img%,height%-2,height%-2
				MaskImage img%,255,255,255
			End If
			SetBuffer ImageBuffer(imageover%)
			Color 60,60,60
			Rect 0,0,width%,height%,1
			For i%=frame% To height%-(frame%*2)
				Color 220-i%,220-i%,220-i%
				Rect frame%,i%,width%-(frame%*2),frame%,1
			Next
			Color 240,240,240
			Oval frame%,-height%*0.5,width%-(frame%*2),height%,1
			Color 60,60,60
			Rect 0,0,width%,frame%,1
			If path$<>"" Then DrawImage img%,0,0
			
			SetBuffer ImageBuffer(imagedown%)
			ClsColor 0,0,0:Cls
			Color 60,60,60
			Rect 0,0,width%,height%,1
			Color 210,210,210
			Rect frame%,frame%,width%-(frame%*2),height%-(frame%*2),1
			If path$<>"" Then DrawImage img%,0,0
			
			frame%=1
			SetBuffer ImageBuffer(imagerelease%)
			Color 60,60,60
			Rect 0,0,width%,height%,1
			For i%=frame% To height%-(frame%*2)
				Color 230-i%,230-i%,230-i%
				Rect frame%,i%,width%-(frame%*2),frame%,1
			Next
			Color 240,240,240
			Oval frame%,-height%*0.5,width%-(frame%*2),height%,1
			Color 60,60,60
			Rect 0,0,width%,frame%,1
			If path$<>"" Then DrawImage img%,frame%-1,frame%-1
			
		Case "Plane"
			frame%=0
			SetBuffer ImageBuffer(imageover%)
			Color 60,60,60
			Rect 0,0,width%,height%,1
			Color 220,220,220
			Rect frame%,frame%,width%-(frame%*2),height%-(frame%*2),1
			If path$<>"" Then DrawImage menugfx%,0,0
			
			SetBuffer ImageBuffer(imagedown%)
			Color 60,60,60
			Rect 0,0,width%,height%,1
			Color 210,210,210
			Rect frame%,frame%,width%-(frame%*2),height%-(frame%*2)+1,1
			If path$<>"" Then DrawImage menugfx%,0,0
			
			SetBuffer ImageBuffer(imagerelease%)
			Color 60,60,60
			Rect 0,0,width%,height%,1
			Color 230,230,230
			Rect frame%,frame%,width%-(frame%*2),height%-(frame%*2),1
			If path$<>"" Then DrawImage menugfx%,0,0
	End Select
End Function

Function CreateMenu(id%,n$,parent%,path$,tt$)
	Local i%,x%,y%,wmax%,img%,frame%=0
	
	If path$<>"" Then img%=LoadImage(path$)
	
	SetFont windowfont%
	
	If parent%=0 Then
		For gui.element=Each element
			If gui\et$="menu" And gui\ep%=0 Then x%=x%+gui\ew%
		Next
	Else
		For gui.element=Each element
			If gui\ei%=parent% Then y%=gui\eh%:x%=gui\ex%
			If gui\et$="menu" And gui\ep%=parent% Then
				y%=y%+gui\eh%
			End If
		Next
	End If
	
	gui.element=New element
	gui\ex%=x%
	gui\ey%=y%
	gui\en$=n$
	If parent%<>0 Then 
		gui\ec%=0
		If path$<>"" Then
			gui\ew%=StringWidth(gui\en$)+frameheight%+5
			gui\etl%=frameheight%
		Else
			gui\ew%=StringWidth(gui\en$)+10
			gui\etl%=5
		End If
	Else
		gui\ec%=1
		If gui\en$<>"" Then gui\ew%=StringWidth(gui\en$)+10 Else gui\ew%=frameheight%
		gui\etl%=gui\ew%*0.5
	End If
	gui\eh%=frameheight%
	
	If path$<>"" Then 
		ResizeImage img%,gui\eh%-2,gui\eh%-2
		MaskImage img%,255,255,255
		gui\mg%=CopyImage(img%)
	End If
	
	gui\eo%=CreateImage(gui\ew%,gui\eh%)
	gui\ed%=CreateImage(gui\ew%,gui\eh%)
	gui\er%=CreateImage(gui\ew%,gui\eh%)
	
	If parent%=0 Then
		GuiStyle(gui\eo%,gui\ed%,gui\er%,gui\ew%,gui\eh%,path$,gui\mg%,"Plane")
	End If
	
	gui\ei%=id%
	gui\ea%=0
	gui\el%=0
	gui\et$="menu"
	gui\sa%=0
	gui\sr%=0
	gui\sb%=0
	gui\sbx%=0
	gui\sby%=0
	gui\sv#=0
	gui\sd#=0
	gui\sm#=0
	gui\so%=0
	gui\ep%=parent%
	If parent%=0 Then gui\ev%=1 Else gui\ev%=0
	gui\ia%=0
	gui\ic%=""
	gui\ef%=windowfont%
	gui\es%=1
	gui\ta%=0
	gui\ett$=tt$
	gui\esw%=0
	
	For gui.element=Each element
		If gui\et$="menu" And gui\ep%=parent% And parent%<>0 Then
			If gui\ew%>wmax% Then wmax%=gui\ew%
		End If
	Next
	For gui.element=Each element
		If gui\et$="menu" And gui\ep%=parent% And parent%<>0 Then
			gui\ew%=wmax%
			gui\eo%=CreateImage(gui\ew%,gui\eh%)
			gui\ed%=CreateImage(gui\ew%,gui\eh%)
			gui\er%=CreateImage(gui\ew%,gui\eh%)
			
			GuiStyle(gui\eo%,gui\ed%,gui\er%,gui\ew%,gui\eh%,path$,gui\mg%,"Plane")
			
		End If
	Next
	
	SetBuffer BackBuffer()
End Function

Function CreateButton(id%,n$,x%,y%,w%,h%,tt$,style$)
	Local i%,frame%=2
	gui.element=New element
	gui\ex%=x%
	gui\ey%=y%+frameheight%
	gui\en$=n$
	gui\ec%=1
	gui\ew%=w%
	gui\eh%=h%
	gui\etl%=gui\ew%*0.5
	gui\eo%=CreateImage(gui\ew%,gui\eh%)
	gui\ed%=CreateImage(gui\ew%,gui\eh%)
	gui\er%=CreateImage(gui\ew%,gui\eh%)
	
	GuiStyle(gui\eo%,gui\ed%,gui\er%,gui\ew%,gui\eh%,"",0,style$)
	
	gui\ei%=id%
	gui\ea%=0
	gui\el%=0
	gui\et$="button"
	gui\sa%=0
	gui\sr%=0
	gui\sb%=0
	gui\sbx%=0
	gui\sby%=0
	gui\sv#=0
	gui\sd#=0
	gui\sm#=0
	gui\so%=0
	gui\ep%=0
	gui\ev%=1
	gui\ia%=0
	gui\ic%=""
	gui\ef%=buttonfont%
	gui\es%=1
	gui\ta%=0
	gui\ett$=tt$
	gui\esw%=0
	
	SetBuffer BackBuffer()
End Function

Function CreateIntake(id%,n$,x%,y%,w%,h%,tt$)
	Local i%,frame%=2
	gui.element=New element
	gui\ex%=x%
	gui\ey%=y%+frameheight%
	gui\en$=n$
	gui\ec%=0
	gui\ew%=w%
	gui\eh%=h%
	gui\etl%=5
	gui\eo%=CreateImage(gui\ew%,gui\eh%)
	gui\ed%=CreateImage(gui\ew%,gui\eh%)
	gui\er%=CreateImage(gui\ew%,gui\eh%)
	
	GuiStyle(gui\eo%,gui\ed%,gui\er%,gui\ew%,gui\eh%,"",0,"Classic")
	
	gui\ei%=id%
	gui\ea%=0
	gui\el%=0
	gui\et$="intake"
	gui\sa%=0
	gui\sr%=0
	gui\sb%=0
	gui\sbx%=0
	gui\sby%=0
	gui\sv#=0
	gui\sd#=0
	gui\sm#=0
	gui\so%=0
	gui\ep%=0
	gui\ev%=1
	gui\ia%=0
	gui\ic%=""
	gui\ef%=intakefont%
	gui\es%=1
	gui\ta%=0
	gui\ett$=tt$
	gui\esw%=0
	
	SetBuffer BackBuffer()
End Function

Function CreateLabel(id%,n$,x%,y%,style$)
	Local i%,frame%=1
	SetFont buttonfont%
	gui.element=New element
	gui\ex%=x%
	gui\ey%=y%+frameheight%
	gui\en$=n$
	gui\ec%=1
	gui\ew%=StringWidth(gui\en$)+20
	gui\eh%=StringHeight(gui\en$)+10
	gui\etl%=gui\ew%*0.5
	gui\eo%=CreateImage(gui\ew%,gui\eh%)
	gui\ed%=CreateImage(gui\ew%,gui\eh%)
	gui\er%=CreateImage(gui\ew%,gui\eh%)
	
	GuiStyle(gui\eo%,gui\ed%,gui\er%,gui\ew%,gui\eh%,"",0,style$)
	
	gui\ei%=id%
	gui\ea%=0
	gui\el%=0
	gui\et$="label"
	gui\sa%=0
	gui\sr%=0
	gui\sb%=0
	gui\sbx%=0
	gui\sby%=0
	gui\sv#=0
	gui\sd#=0
	gui\sm#=0
	gui\so%=0
	gui\ep%=0
	gui\ev%=1
	gui\ia%=0
	gui\ic%=""
	gui\ef%=labelfont%
	gui\es%=1
	gui\ta%=0
	gui\ett$=""
	gui\esw%=0
	
	SetBuffer BackBuffer()
End Function

Function CreateList(id%,x%,y%,w%,h%,tt$,style$)
	Local i%,frame%=2
	gui.element=New element
	gui\ex%=x%
	gui\ey%=y%+frameheight%
	gui\en$=""
	gui\ec%=1
	gui\ew%=w%
	gui\eh%=h%
	gui\etl%=gui\ew%*0.5
	gui\eo%=CreateImage(gui\ew%,gui\eh%)
	gui\ed%=CreateImage(gui\ew%,gui\eh%)
	gui\er%=CreateImage(gui\ew%,gui\eh%)
	
	GuiStyle(gui\eo%,gui\ed%,gui\er%,gui\ew%,gui\eh%,"",0,style$)
	
	gui\ei%=id%
	gui\ea%=0
	gui\el%=0
	gui\et$="list"
	gui\sa%=0
	gui\sr%=0
	gui\sb%=0
	gui\sbx%=0
	gui\sby%=0
	gui\sv#=0
	gui\sd#=0
	gui\sm#=0
	gui\so%=0
	gui\ep%=0
	gui\ev%=1
	gui\ia%=0
	gui\ic%=""
	gui\ef%=buttonfont%
	gui\es%=1
	gui\ta%=0
	gui\ett$=tt$
	gui\esw%=0
	
	SetBuffer BackBuffer()
End Function

Function CreateSwitch(id%,o%,x%,y%,w%,h%,tt$,en$,style$)
	Local i%,frame%=2,barheight#=0.3
	gui.element=New element
	gui\ex%=x%
	gui\ey%=y%+frameheight%
	gui\ew%=w%
	gui\eh%=h%
	gui\etl%=gui\ew%*0.5
	gui\eo%=CreateImage(gui\ew%,gui\eh%)
	gui\ed%=CreateImage(gui\ew%,gui\eh%)
	gui\er%=CreateImage(gui\ew%,gui\eh%)
	
	GuiStyle(gui\eo%,gui\ed%,gui\er%,gui\ew%,gui\eh%,"",0,style$)
	
	gui\ei%=id%
	gui\ea%=0
	gui\el%=0
	gui\et$="switch"
	gui\sa%=0
	If o%=1 Then gui\sr%=gui\ew%*2 Else gui\sr%=gui\eh%*2
	If en$="ON/OFF" Then gui\en$="ON"
	If en$="L/R" Then gui\en$="L"
	gui\ec%=1
	gui\sd#=0
	gui\sv#=0
	gui\sm#=0
	
	Select o%
		Case 1
			gui\sbx%=gui\ex%
			gui\sby%=gui\ey%+(gui\eh%-(gui\eh%*barheight#))*0.5
			gui\sb%=CreateImage(gui\sr%,gui\eh%*barheight#)
			BarStyle(1,gui\sb%,gui\ew%,gui\eh%,gui\sr%,barheight#)
			gui\so%=0
		Case 2
			gui\sbx%=gui\ex%+(gui\ew%-(gui\ew%*barheight#))*0.5
			gui\sby%=gui\ey%
			gui\sb%=CreateImage(gui\ew%*barheight#,gui\sr%)
			BarStyle(2,gui\sb%,gui\ew%,gui\eh%,gui\sr%,barheight#)
			gui\so%=1
	End Select
	
	gui\ep%=0
	gui\ev%=1
	gui\ia%=0
	gui\ic%=""
	gui\ef%=switchfont%
	gui\es%=1
	gui\ta%=0
	gui\ett$=tt$
	gui\esw%=0
	
	SetBuffer BackBuffer()
End Function

Function BarStyle(orientation%,image%,width%,height%,range%,barheight#)
	Select orientation%
		Case 1
			SetBuffer ImageBuffer(image%)
			ClsColor 40,40,40:Cls
			Color 60,60,60
			Rect 0,0,range%,height%*barheight#,0
			Color 150,150,150
			Rect 0,height%*barheight#-1,range%,1,1
		Case 2
			SetBuffer ImageBuffer(image%)
			ClsColor 40,40,40:Cls
			Color 60,60,60
			Rect 0,0,height%*barheight#,range%,0
			Color 150,150,150
			Rect 0,range%-1,width%*barheight#,1,1
	End Select
End Function

Function CreateSlider(id%,o%,x%,y%,w%,h%,r%,d#,v#,p#,tt$,style$)
	Local i%,frame%=2,barheight#=0.3
	gui.element=New element
	gui\ex%=x%
	gui\ey%=y%+frameheight%
	gui\ew%=w%
	gui\eh%=h%
	gui\etl%=gui\ew%*0.5
	gui\eo%=CreateImage(gui\ew%,gui\eh%)
	gui\ed%=CreateImage(gui\ew%,gui\eh%)
	gui\er%=CreateImage(gui\ew%,gui\eh%)
	
	GuiStyle(gui\eo%,gui\ed%,gui\er%,gui\ew%,gui\eh%,"",0,style$)
	
	gui\ei%=id%
	gui\ea%=0
	gui\el%=0
	gui\et$="slider"
	gui\sa%=0
	gui\sr%=r%
	gui\en$=Str(Int(d#*p#))
	gui\ec%=1
	gui\sd#=d#
	gui\sv#=p#
	gui\sm#=v#
	
	Select o%
		Case 1
			gui\sbx%=gui\ex%-((gui\sr%-gui\ew%)*p#)
			gui\sby%=gui\ey%+(gui\eh%-(gui\eh%*barheight#))*0.5
			gui\sb%=CreateImage(gui\sr%,gui\eh%*barheight#)
			BarStyle(1,gui\sb%,gui\ew%,gui\eh%,gui\sr%,barheight#)
			gui\so%=0
		Case 2
			gui\sbx%=gui\ex%+(gui\ew%-(gui\ew%*barheight#))*0.5
			gui\sby%=gui\ey%-((gui\sr%-gui\eh%)*p#)
			gui\sb%=CreateImage(gui\eh%*barheight#,gui\sr%)
			BarStyle(2,gui\sb%,gui\ew%,gui\eh%,gui\sr%,barheight#)
			gui\so%=1
	End Select
	
	gui\ep%=0
	gui\ev%=1
	gui\ia%=0
	gui\ic%=""
	gui\ef%=sliderfont%
	gui\es%=1
	gui\ta%=0
	gui\ett$=tt$
	gui\esw%=0
	
	SetBuffer BackBuffer()
End Function

Function AddListItem(id%,parent%,n$,path$)
	Local i%,x%,y%,w%,h%,yoffset%,frame%=2
	
	For gui.element=Each element
		If gui\ei%=parent% Then
			x%=gui\ex%
			y%=gui\ey%
			w%=gui\ew%
			h%=gui\eh%
		End If
	Next
	
	For gui.element=Each element
		If gui\et$="item" And gui\ep%=parent% Then yoffset%=gui\ey%-y%+gui\eh%
	Next
	
	gui.element=New element
	gui\ex%=x%+5
	gui\ey%=y%+yoffset%+5
	gui\en$=n$
	gui\ec%=0
	gui\ew%=w%-10
	gui\eh%=40
	If path$<>"" Then gui\etl%=gui\eh%+10 Else gui\etl%=10
	gui\eo%=CreateImage(gui\ew%,gui\eh%)
	gui\ed%=CreateImage(gui\ew%,gui\eh%)
	gui\er%=CreateImage(gui\ew%,gui\eh%)
	
	GuiStyle(gui\eo%,gui\ed%,gui\er%,gui\ew%,gui\eh%,path$,0,"SquareGloss")
	
	gui\ei%=id%
	gui\ea%=0
	gui\el%=0
	gui\et$="item"
	gui\sa%=0
	gui\sr%=0
	gui\sb%=0
	gui\sbx%=0
	gui\sby%=0
	gui\sv#=0
	gui\sd#=0
	gui\sm#=0
	gui\so%=0
	gui\ep%=parent%
	If gui\ey%+gui\eh%<y%+h% Then gui\ev%=1 Else gui\ev%=0
	gui\ia%=0
	gui\ic%=path$
	gui\ef%=itemfont%
	gui\es%=1
	gui\ta%=0
	gui\ett$=""
	gui\esw%=0
	
	SetBuffer BackBuffer()
End Function

Function ScrollList(parent%)
	Local ymin%,ymax%,scrollmin%,scrollmax%,scrollvalue%,noscroll%,items%,itemh%
	
	For gui.element=Each element
		If gui\et$="item" And gui\ep%=parent% Then
			items%=items%+1
			If items%=1 Then scrollmin%=gui\ey%:itemh%=gui\eh% Else scrollmax%=gui\ey%
		End If
		If gui\ei%=parent% Then
			ymin%=gui\ey%+5
			ymax%=gui\ey%+gui\eh%-5
		End If
	Next
	
	scrollvalue%=MouseZSpeed()*(itemh%+5)
	
	For gui.element=Each element
		If gui\ep%=parent% Then
			If gui\ey%+scrollvalue%>ymin%+((items%-1)*(itemh%+5)) Or gui\ey%+scrollvalue%<=ymax%-((items%+0)*(itemh%+5)) Then noscroll%=1
		End If
	Next
	
	If noscroll%=0 Then
		For gui.element=Each element
			If gui\ep%=parent% Then
				gui\ey%=gui\ey%+scrollvalue%
				If gui\ey%<ymin% Or gui\ey%+gui\eh%>ymax% Then gui\ev%=0 Else gui\ev%=1
			End If
		Next
	End If
End Function

Function UpdateGui()
	Local lb%,entry$,showtip%,tt$
	UpdateWindowFrame()
	For gui.element=Each element
		SetFont gui\ef%
		If ImageRectOverlap(collider%,MouseX(),MouseY(),gui\ex%,gui\ey%,gui\ew%,gui\eh%)=True And gui\ev%=1 And gui\es%=1 Then
			If gui\ett%<>"" And showtip%=0 Then showtip%=1:tt$=gui\ett%
			statustime%=MilliSecs()
			If gui\et$="menu" And menuactive%=1 Then GuiControl(gui\ei%)
			If MouseHit(1)=True Then gui\ea%=1
			If MouseDown(1)=True Then
				If gui\et$="slider" And gui\ea%=1 Then gui\sa%=1
				If gui\et$="item" Then gui\ia%=1
				If gui\et%="slider" Or gui\et%="switch" And gui\ev%=1 Then DrawImage gui\sb%,gui\sbx%,gui\sby%
				If gui\ev%=1 Then DrawImage gui\ed%,gui\ex%,gui\ey%
				gui\el%=1
			Else
				If gui\et%="slider" Or gui\et%="switch" And gui\ev%=1 Then DrawImage gui\sb%,gui\sbx%,gui\sby%
				If gui\ev%=1 Then DrawImage gui\eo%,gui\ex%,gui\ey%
				If gui\ea%=1 Then menuactive%=0:GuiControl(gui\ei%):GuiAction(gui\ei%,gui\sv#,""):gui\ea%=0
				If gui\ia%=1 Then GuiControl(gui\ei%):GuiAction(gui\ei%,gui\sv#,""):gui\ia%=0
				If gui\et%="list" Then ScrollList(gui\ei%)
				gui\ea%=2
			End If
			If gui\ev%=1 Then Text gui\ex%+gui\etl%,gui\ey%+gui\eh%*0.5,gui\en%,gui\ec%,1
			If gui\ei%<>lastelement% And gui\et%<>"item" Then tooltiptime%=MilliSecs()
			If gui\et%<>"item" Then lastelement%=gui\ei%
		Else
			If gui\ea%=2 Or gui\el%=1 Then gui\el%=0:gui\ea%=0
			If gui\et%="slider" Or gui\et%="switch" And gui\ev%=1 Then DrawImage gui\sb%,gui\sbx%,gui\sby%
			If gui\ev%=1 Then DrawImage gui\er%,gui\ex%,gui\ey%
			If gui\ev%=1 Then Text gui\ex%+gui\etl%,gui\ey%+gui\eh%*0.5,gui\en%,gui\ec%,1
		End If
		
		If gui\sa%=1 And MouseDown(1)=True Then 
			Select gui\so%
				Case 0
					If MouseX()-gui\ew%*0.5<=gui\sbx% Then
						gui\ex%=gui\sbx%
						lb%=1
					Else
						gui\ex%=MouseX()-gui\ew%*0.5
					End If
					If lb%<>1 Then
						If MouseX()-gui\ew%*0.5>=gui\sbx%+gui\sr%-gui\ew% Then
							gui\ex%=gui\sbx%+gui\sr%-gui\ew%
						Else
							gui\ex%=MouseX()-gui\ew%*0.5
						End If
					End If
					gui\en$=Str(Int(gui\sd#*Float(0.01)*(100-Float(100)/(Float(gui\sr%)-Float(gui\ew%))*((Float(gui\sbx%)+Float(gui\sr%))-Float(gui\ex%)-Float(gui\ew%)))))
					gui\sv#=gui\sm#*Float(0.01)*(100-Float(100)/(Float(gui\sr%)-Float(gui\ew%))*((Float(gui\sbx%)+Float(gui\sr%))-Float(gui\ex%)-Float(gui\ew%)))
				Case 1
					If MouseY()-gui\eh%*0.5<=gui\sby% Then
						gui\ey%=gui\sby%
						lb%=1
					Else
						gui\ey%=MouseY()-gui\eh%*0.5
					End If
					If lb%<>1 Then
						If MouseY()-gui\eh%*0.5>=gui\sby%+gui\sr%-gui\eh% Then
							gui\ey%=gui\sby%+gui\sr%-gui\eh%
						Else
							gui\ey%=MouseY()-gui\eh%*0.5
						End If
					End If
					gui\en$=Str(Int(gui\sd#*Float(0.01)*(100-Float(100)/(Float(gui\sr%)-Float(gui\eh%))*((Float(gui\sby%)+Float(gui\sr%))-Float(gui\ey%)-Float(gui\eh%)))))
					gui\sv#=gui\sm#*Float(0.01)*(100-Float(100)/(Float(gui\sr%)-Float(gui\eh%))*((Float(gui\sby%)+Float(gui\sr%))-Float(gui\ey%)-Float(gui\eh%)))
			End Select
			GuiAction(gui\ei%,gui\sv#,"")
		Else 
			gui\sa%=0
		End If
		
		If gui\ta%=1 Then
			
			Color 255,255,255
			Rect gui\ex%+gui\etl%,gui\ey%+StringHeight(gui\en$)*0.5,gui\ew%-gui\etl%*2,StringHeight(gui\en$)
			entry$=Intake("",gui\ex%+gui\etl%,gui\ey%+gui\eh%*0.5,20,200)
			If entry$<>"" Then gui\en$=entry$:gui\ta%=0
		End If
		
	Next
	
	If showtip%=1 Then ShowToolTip(MouseX(),MouseY(),tt$):showtip%=0
	
	If MouseHit(1)=True And menuactive%=1 Then HideMenu()
	status5$=CurrentDate()+" "+CurrentTime()
	FlushMouse
End Function

Function ShowToolTip(x%,y%,tt$)
	If MilliSecs()>tooltiptime%+2000 Then
		SetFont windowfont%
		Local width%=StringWidth(tt$)+10
		Local height%=StringHeight(tt$)+10
		Color 60,60,60
		Rect x%+20+2,y%+2,width%,height%,1
		Color 200,200,50
		Rect x%+20,y%,width%,height%,1
		Color 60,60,60
		Text x%+5+20,y%+(height%*0.5),tt$,0,1
	End If
End Function

Function GuiControl(id%)
	For gui.element=Each element
		gui\ta%=0
		If gui\ei%=id% Then
			If gui\et$="switch" Then 
				If gui\esw%=0 Then
					If gui\so%=0 Then gui\ex%=gui\ex%+gui\sr%*0.5 Else gui\ey%=gui\ey%+gui\sr%*0.5
					gui\esw%=1
					If gui\en$="ON" Then gui\en$="OFF"
					If gui\en$="L" Then gui\en$="R"
				Else
					If gui\so%=0 Then gui\ex%=gui\ex%-gui\sr%*0.5 Else gui\ey%=gui\ey%-gui\sr%*0.5
					gui\esw%=0
					If gui\en$="OFF" Then gui\en$="ON"
					If gui\en$="R" Then gui\en$="L"
				End If
			End If
			
			If gui\et$="item" And Instr(gui\ic$,"png")<>0 Then GuiAction(gui\ep%,0,gui\ic$)
			If gui\et$="menu" And gui\ep%=0 Then ShowMenu(id%):menuactive%=1
			If gui\et$="menu" And gui\ep%<>0 And menuactive%=0 Then HideMenu()
			If gui\et$="intake" Then gui\ta%=1:sjintakestring$=gui\en$
		End If
	Next
End Function

Function SetStatusText(position%,statustext$)
	Select position%
		Case 1
			status1$=statustext$
		Case 2
			status2$=statustext$
		Case 3
			status3$=statustext$
		Case 4
			status4$=statustext$
		Case 5
			status5$=statustext$
	End Select
End Function

Function ShowMenu(id%)
	For gui.element=Each element
		If gui\ep%=id% Then gui\ev%=1
		If gui\ep%<>id% And gui\ep%<>0 And gui\et$="menu" Then gui\ev%=0
		If gui\et$<>"menu" Then gui\es%=0
	Next
End Function

Function HideMenu()
	For gui.element=Each element
		If gui\et$="menu" And gui\ep%<>0 Then gui\ev%=0
		gui\es%=1
	Next
	menuactive%=0
End Function

Function Intake$(sjinputtext$,sjinputxloc,sjinputyloc,sjmaxcharacters,sjmaxstringwidth)
	Local keyin=GetKey()
	If keyin>0 Then 
		If keyin=8
			If Len(sjintakestring$)>0 Then sjintakestring$=Left$(sjintakestring$,Len(sjintakestring$)-1)
		ElseIf keyin=13
			Local sjreturnstring$=sjintakestring$
			sjintakestring$=""
			Return sjreturnstring$
		Else 
			sjintakestring$=sjintakestring$+Chr$(keyin)
		EndIf
	EndIf 
	
	If Len(sjintakestring$)>sjmaxcharacters
		sjintakestring$=Left$(sjintakestring$,Len(sjintakestring$)-1)
	EndIf
	
	If StringWidth(sjintakestring$)>sjmaxstringwidth
		sjintakestring$=Left$(sjintakestring$,Len(sjintakestring$)-1)
	EndIf
	
	sjcursorblink=sjcursorblink-1
	If sjcursorblink<=0 Then sjcursorblink=sjcursorblinkrate
	Color 0,0,0
	If sjcursorblink<sjcursorblinkrate/2
		Text sjinputxloc,sjinputyloc,sjinputtext$+sjintakestring$+"_",0,1
	Else
		Text sjinputxloc,sjinputyloc,sjinputtext$+sjintakestring$,0,1
	EndIf 
End Function


;~IDEal Editor Parameters:
;~F#19#43#5C#66#77#7B#8B#96#26A#2CB#2F5#31F#34A#374#3AB#3BE#3F4#42C#44C#4A7
;~F#4B5#4CF#4DE#4E6#4EE
;~C#Blitz3D